WoMax Documentation

# O_oracle Class Reference
[Factor Oracle structure]

Factor Oracle (FO) class. More...

`#include <Oracle_classes.hpp>`

Collaboration diagram for O_oracle:
[legend]

List of all members.

## Protected Attributes
int | size
| Current size of FO.
vector< O_state * > | state_vect
| Vector of references to all the state of FO.
## Public Member Functions
void | freestates ()
| Reset.
void | start ()
| Initialisation.
Constructors & Destructors
| O_oracle ()
| Default constructor.
| O_oracle (const O_oracle &)
| Copy constructor.
| ~O_oracle ()
| Standard destructor.
Set & Get
int | get_size ()
| Return the current size of FO.
## Friends
class | O_learner
## Operators Overload
ostream & | operator<< (ostream &, const O_oracle &)
| Output all the states of FO on a standard stream.
O_state * | operator[] (int) const
| Access FO states.

## Detailed Description

Factor Oracle (FO) class.

This class implements the sequence of states, initialisation, access and freeing of FO

Definition at line 104 of file Oracle_classes.hpp.

## Constructor & Destructor Documentation

O_oracle::O_oracle | ( |  | ) |

Default constructor.

Remarks:
  Size is initialise to -1

Definition at line 235 of file Oracle_classes.cpp.

O_oracle::~O_oracle | ( |  | ) |

Standard destructor.

Remarks:
  Delete and free the memory for every state of FO

Definition at line 242 of file Oracle_classes.cpp.

## Member Function Documentation

void O_oracle::freestates | ( |  | ) |

Reset.

Delete and free the memory for every state of FO and resets the size

Definition at line 250 of file Oracle_classes.cpp.

O_state * O_oracle::operator[] | ( | int | i | ) | const

Access FO states.

Remarks:
  State numbers start from 0

Definition at line 280 of file Oracle_classes.cpp.

void O_oracle::start | ( |  | ) |

Initialisation.

Create the first state of FO (numbered 0) with no transitions, no suffix nor reverse suffix links and set size to 1

Definition at line 268 of file Oracle_classes.cpp.

The documentation for this class was generated from the following files:

- Oracle_classes.hpp
- Oracle_classes.cpp